; LoadImageFromMem version 1.0 by Vortex

; References :

; Load JPEG and (transparant) GIF picture files from a resource in 3 lines code.
; http://www.codeproject.com/KB/graphics/load_jpeg__gif_resource.aspx

; Going from a JPG/GIF/BMP File to a HBITMAP File Using Plain API
; http://www.codeguru.com/cpp/g-m/bitmap/article.php/c4935

.386
.model flat,stdcall
option casemap:none

include LoadImage.inc

.data

IID_IPicture GUID <7BF80980h,0BF32h,101Ah,<8Bh,0BBh,00h,0AAh,00h,30h,0Ch,0ABh>>

.code

LoadImageFromMem PROC USES esi edi pImageAddr:DWORD,ImageLen:DWORD

LOCAL hOLEimg:DWORD
LOCAL hBitmap:DWORD
LOCAL pPicture:DWORD
LOCAL pStream:DWORD
LOCAL hGlobal:DWORD

    mov     hBitmap,0
    mov     pStream,0
    mov     pPicture,0

    invoke  GlobalAlloc,GMEM_MOVEABLE or GMEM_NODISCARD,ImageLen
    test    eax,eax
    jz      _exit
    mov     hGlobal,eax
    invoke  GlobalLock,eax
    test    eax,eax
    jz      _exit

    cld
    mov     esi,pImageAddr
    mov     edi,eax
    mov     ecx,ImageLen
    shr     ecx,2
    rep     movsd

    mov     ecx,ImageLen
    and     ecx,3
    rep     movsb

    invoke  CreateStreamOnHGlobal,hGlobal,TRUE,ADDR pStream
    test    eax,eax
    jz      @f
    invoke  GlobalUnlock,hGlobal
    invoke  GlobalFree,hGlobal
    jmp     _exit
@@:
    invoke  OleLoadPicture,pStream,0,FALSE,ADDR IID_IPicture,ADDR pPicture
    test    eax,eax
    jnz     ReleaseStream

    lea     eax,hOLEimg
    push    eax
    mov     eax,pPicture
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.get_Handle[eax]
    test    eax,eax
    jnz     ReleasePict

    invoke  CopyImage,hOLEimg,IMAGE_BITMAP,0,0,LR_COPYRETURNORG
    test    eax,eax
    jz      ReleasePict
    mov     hBitmap,eax

ReleasePict:

    mov     eax,pPicture
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.Release[eax]

ReleaseStream:

    mov     eax,pStream
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IStream.IUnknown.Release[eax]

_exit:

    mov     eax,hBitmap
    ret    

LoadImageFromMem ENDP

END

